static const char *RcsId = "$Header: /home/cvsadm/cvsroot/AbstractClasses/SpectrumAnalyzer/SpectrumAnalyzerStateMachine.cpp,v 1.1 2008/04/23 12:27:46 claudio Exp $";
//+=============================================================================
//
// file :         SpectrumAnalyzerStateMachine.cpp
//
// description :  C++ source for the SpectrumAnalyzer and its alowed. 
//                method for commands and attributes
//
// project :      TANGO Device Server
//
// $Author: claudio $
//
// $Revision: 1.1 $
//
// $Log: SpectrumAnalyzerStateMachine.cpp,v $
// Revision 1.1  2008/04/23 12:27:46  claudio
// first import
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#include <tango.h>
#include <SpectrumAnalyzer.h>
#include <SpectrumAnalyzerClass.h>

/*====================================================================
 *	This file contains the methods to allow commands and attributes
 * read or write execution.
 *
 * If you wand to add your own code, add it between 
 * the "End/Re-Start of Generated Code" comments.
 *
 * If you want, you can also add your own methods.
 *====================================================================
 */

namespace SpectrumAnalyzer_ns
{

//=================================================
//		Attributes Allowed Methods
//=================================================

//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_Span_allowed
// 
// description : 	Read/Write allowed for Span attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_Span_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_CenterFrequency_allowed
// 
// description : 	Read/Write allowed for CenterFrequency attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_CenterFrequency_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_MarkerX_allowed
// 
// description : 	Read/Write allowed for MarkerX attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_MarkerX_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT	||
		get_state() == Tango::DISABLE)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_MarkerY_allowed
// 
// description : 	Read/Write allowed for MarkerY attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_MarkerY_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT	||
		get_state() == Tango::DISABLE)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_ErrorPolling_allowed
// 
// description : 	Read/Write allowed for ErrorPolling attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_ErrorPolling_allowed(Tango::AttReqType type)
{
		//	End of Generated Code

		//	Re-Start of Generated Code
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_Attenuation_allowed
// 
// description : 	Read/Write allowed for Attenuation attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_Attenuation_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_DetectorType_allowed
// 
// description : 	Read/Write allowed for DetectorType attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_DetectorType_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_StartFrequency_allowed
// 
// description : 	Read/Write allowed for StartFrequency attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_StartFrequency_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_StopFrequency_allowed
// 
// description : 	Read/Write allowed for StopFrequency attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_StopFrequency_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_FreqOffset_allowed
// 
// description : 	Read/Write allowed for FreqOffset attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_FreqOffset_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_ReferenceLevel_allowed
// 
// description : 	Read/Write allowed for ReferenceLevel attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_ReferenceLevel_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_StartStop_allowed
// 
// description : 	Read/Write allowed for StartStop attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_StartStop_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_TraceReal32_allowed
// 
// description : 	Read/Write allowed for TraceReal32 attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_TraceReal32_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_TraceInt32_allowed
// 
// description : 	Read/Write allowed for TraceInt32 attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_TraceInt32_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_OPC_allowed
// 
// description : 	Read/Write allowed for OPC attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_OPC_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT	||
		get_state() == Tango::DISABLE)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_ResolutionBandwidth_allowed
// 
// description : 	Read/Write allowed for ResolutionBandwidth attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_ResolutionBandwidth_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_PeakThreshold_allowed
// 
// description : 	Read/Write allowed for PeakThreshold attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_PeakThreshold_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_PeakExcursion_allowed
// 
// description : 	Read/Write allowed for PeakExcursion attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_PeakExcursion_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_GetSignalPeaks_allowed
// 
// description : 	Read/Write allowed for GetSignalPeaks attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_GetSignalPeaks_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT	||
		get_state() == Tango::DISABLE)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_Fs_allowed
// 
// description : 	Read/Write allowed for Fs attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_Fs_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT	||
		get_state() == Tango::DISABLE)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_WindowFs_allowed
// 
// description : 	Read/Write allowed for WindowFs attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_WindowFs_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT	||
		get_state() == Tango::DISABLE)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_Window_allowed
// 
// description : 	Read/Write allowed for Window attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_Window_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT	||
		get_state() == Tango::DISABLE)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_NumberOfSweeps_allowed
// 
// description : 	Read/Write allowed for NumberOfSweeps attribute.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_NumberOfSweeps_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT	||
		get_state() == Tango::DISABLE)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}

//=================================================
//		Commands Allowed Methods
//=================================================

//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_Reset_allowed
// 
// description : 	Execution allowed for Reset command.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_Reset_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_ClearStatus_allowed
// 
// description : 	Execution allowed for ClearStatus command.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_ClearStatus_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_Remote_allowed
// 
// description : 	Execution allowed for Remote command.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_Remote_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_Local_allowed
// 
// description : 	Execution allowed for Local command.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_Local_allowed(const CORBA::Any &any)
{
		//	End of Generated Code

		//	Re-Start of Generated Code
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_GetPeak_allowed
// 
// description : 	Execution allowed for GetPeak command.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_GetPeak_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT	||
		get_state() == Tango::DISABLE)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_SetSingleSweep_allowed
// 
// description : 	Execution allowed for SetSingleSweep command.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_SetSingleSweep_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT	||
		get_state() == Tango::DISABLE)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_ChangePowUnits_allowed
// 
// description : 	Execution allowed for ChangePowUnits command.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_ChangePowUnits_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT	||
		get_state() == Tango::DISABLE)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_GetErrorInfo_allowed
// 
// description : 	Execution allowed for GetErrorInfo command.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_GetErrorInfo_allowed(const CORBA::Any &any)
{
		//	End of Generated Code

		//	Re-Start of Generated Code
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_GetMin_allowed
// 
// description : 	Execution allowed for GetMin command.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_GetMin_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT	||
		get_state() == Tango::DISABLE)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_SetContinuousSweep_allowed
// 
// description : 	Execution allowed for SetContinuousSweep command.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_SetContinuousSweep_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT	||
		get_state() == Tango::DISABLE)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_RestartMeasurement_allowed
// 
// description : 	Execution allowed for RestartMeasurement command.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_RestartMeasurement_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT	||
		get_state() == Tango::DISABLE)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_SetAutoAttenuation_allowed
// 
// description : 	Execution allowed for SetAutoAttenuation command.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_SetAutoAttenuation_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_GetAutoAttenuation_allowed
// 
// description : 	Execution allowed for GetAutoAttenuation command.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_GetAutoAttenuation_allowed(const CORBA::Any &any)
{
		//	End of Generated Code

		//	Re-Start of Generated Code
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_SetAsciiData_allowed
// 
// description : 	Execution allowed for SetAsciiData command.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_SetAsciiData_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_SetINT32Data_allowed
// 
// description : 	Execution allowed for SetINT32Data command.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_SetINT32Data_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_SetReal32Data_allowed
// 
// description : 	Execution allowed for SetReal32Data command.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_SetReal32Data_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_GetDataFormat_allowed
// 
// description : 	Execution allowed for GetDataFormat command.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_GetDataFormat_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_SaveData_allowed
// 
// description : 	Execution allowed for SaveData command.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_SaveData_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		SpectrumAnalyzer::is_PrintData_allowed
// 
// description : 	Execution allowed for PrintData command.
//
//-----------------------------------------------------------------------------
bool SpectrumAnalyzer::is_PrintData_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}

}	// namespace SpectrumAnalyzer_ns
